( forth ifdef/macro support )

\ support words for conditional words

\ read next token from input stream
: gettoken ( -- c-adr )
  BL WORD DUP C@ 0= IF 
    DROP REFILL DROP BL WORD 
  THEN ;

\ see if the next token is a conditional word
\ returns 1 = [THEN], 2 = [ELSE] or 3 = [IF], 0 = not a conditional word
: if-token? ( -- f ) 
  BEGIN 
    gettoken DUP C@ 
  WHILE
    DUP S" [THEN]" SWAP 1- SWAP
    S= 0= IF 
      DROP 1 EXIT 
    ELSE 
      DUP S" [ELSE]" SWAP 1- SWAP
      S= 0= IF
        DROP 2 EXIT 
      ELSE DUP S" [IF]" SWAP 1- SWAP
        S= 0= IF 
          DROP 3 EXIT 
        THEN 
      THEN 
    THEN 
    DROP 
  REPEAT 
  DROP 0 ;

\ main conditional words [IF], [ELSE] and [THEN].

: [THEN] ( -- ) ; IMMEDIATE 
  0 VALUE if-cnt

: [IF] ( f -- ) 
  0 TO if-cnt 
  NOT IF
    BEGIN 
      if-token? DUP 
    WHILE
      DUP 3 = IF
        if-cnt 1+ TO if-cnt 
      ELSE
        DUP 2 = IF
          if-cnt 0= IF 
            DROP EXIT 
          THEN 
        ELSE
          DUP 1 = IF
            if-cnt 0= IF
              DROP EXIT 
            ELSE 
              if-cnt 1- TO if-cnt 
            THEN 
          THEN 
        THEN 
      THEN 
      DROP 
    REPEAT 
  THEN ; IMMEDIATE

: [ELSE] ( -- )
  BEGIN 
    if-token? DUP 
  WHILE
    DUP 3 = IF
      if-cnt 1+ TO if-cnt 
    ELSE
      DUP 1 = IF
        if-cnt 0= IF
          DROP EXIT 
        ELSE 
          if-cnt 1- TO if-cnt 
        THEN 
      THEN
    THEN 
    DROP 
  REPEAT ; IMMEDIATE
