( propellar TV text driver )

: FIELD: ( idx -) ( buff - a) CREATE C, DOES> C@ CELLS CELLS + ;

#2 FIELD: >tv_pins

\ These constants are for NTSC TV runtime

\ Block index that contains TV binary.
 #5  VALUE  tv_blk 

\ Size of screen
#40  CONSTANT  tv_cols
#13  CONSTANT  tv_rows
tv_cols tv_rows * CONSTANT tv_screensize

\ There are 14 longs in the TV parameter block
\ Allocate a variable with (14 * 4) bytes of storage
#14 #2 LSHIFT QBYTES tv_params

\ Screen buffer
\ Allocate one 16 bit word for each screen character
tv_screensize CELLS QBYTES tv_screen

\ Color table holds 8 colors, uses 2 longs for each color
\ Allocate space for 16 longs
#16 CELLS CELLS QBYTES tv_pallete

\ A forth VALUE to hold COG used to run binary
0 VALUE tv_cog

\ Allows us to unload initialization code
MARKER tv_unload_init

\ These constants are for NTSC TV initialization

#48  VALUE tv_pins
#26. 2CONSTANT tv_mode
 #4. 2CONSTANT tv_hx

( TV field paramaters )
#0 FIELD: >tv_status  #1 FIELD: >tv_enable
#2 FIELD: >tv_pins    #3 FIELD: >tv_mode
#4 FIELD: >tv_screen  #5 FIELD: >tv_colors
#6 FIELD: >tv_hc      #7 FIELD: >tv_vc
#8 FIELD: >tv_hx      #9 FIELD: >tv_vx
#10 FIELD: >tv_ho     #11 FIELD: >tv_vo
#12 FIELD: >tv_broadcast
#13 FIELD: >tv_auralcog


( initial TV parameter values )
0. tv_params >tv_status Q!  
1. tv_params >tv_enable Q!  
tv_mode tv_params >tv_mode Q!
tv_screen S>D tv_params >tv_screen Q!
tv_pallete S>D tv_params >tv_colors Q!
tv_cols S>D tv_params >tv_hc Q!
tv_rows S>D tv_params >tv_vc Q!
tv_hx tv_params >tv_hx Q!  
1. tv_params >tv_vx Q!
0. tv_params >tv_ho Q!  
0. tv_params >tv_vo Q!
0. tv_params >tv_broadcast Q!
0. tv_params >tv_auralcog Q!  

: rgb>qvars ( cFGCLR cBGCLR - d1 d2 )
 $FF AND SWAP $FF AND
 2DUP 2>R #8 LSHIFT OR DUP 
 R@ R> #8 LSHIFT OR
 R@ R> #8 LSHIFT OR SWAP 2SWAP ;
 

BASE @ HEX
: tv-mkcolors CREATE
  07 C, 02 C,  \ white on black
  02 C, 07 C,  \ black on white
  07 C, 0A C,  \ white on blue
  9E C, 0A C,  \ yellow on blue
  9E C, 9B C,  \ yellow on olive
  9B C, 9E C,  \ olive on yellow
  07 C, CA C,  \ white on red
  07 C, 7A C,  \ white on green
  DOES> SWAP CELLS + DUP C@ SWAP 1+ C@ rgb>qvars ;
BASE !

tv-mkcolors tv_basecolors

: tv-calc-color ( uIDX - ) DUP tv_pallete SWAP
  CELLS CELLS CELLS + DUP CELL + CELL + >R
  SWAP tv_basecolors 2SWAP R> Q! ROT Q! ;
  
: tv-calc-colors #8 0 DO I tv-calc-color LOOP ;

tv-calc-colors

tv_unload_init


\ TV driver will use 3 pins starting from uPinNumber
\ valid pin values are 0, 4, 8, 12, 16, 20, 24
: tv-setpins ( uPinNumber -- )
  DUP
  ( caculate pin bits 4..6 )
  #8 / #4 LSHIFT
  ( calculate pin bits 0..3 )
  SWAP 8 MOD 3 > IF
    %0101
  ELSE
    %0000
  THEN
  OR S>D tv_params >tv_pins Q! ;

( Start TV driver cog )
: tv-run ( -- )
  tv_params tv_blk COG-LOAD TO tv_cog ;

( Stop TV driver cog )
: tv-stop ( -- )
  tv_cog ?DUP IF
    COG-STOP
    0 TO tv_cog
  THEN ;

( TV driver cog support routines )

: tv-adr ( uX uY -- uAdr )
  tv_cols * + CELLS tv_screen + ;

: tv-enc ( uColIdx cChar - uWord ) 
  DUP 1 AND ROT 1 LSHIFT + #10
  LSHIFT $200 + SWAP $FE AND + ;

: tv-cln ( uColIdx uRow - )
  SWAP $20 tv-enc SWAP tv_cols *
  CELLS tv_screen + 
  tv_cols 0 DO 
    2DUP ! CELL + 
  LOOP 
  2DROP ;

: tv-cls ( UColIdx - ) 
  tv_rows 0 DO 
    DUP I tv-cln 
  LOOP 
  DROP ;

: tv-out ( uX uY uColIdx cChar - ) 
  tv-enc ROT ROT tv-adr ! ;
  