.( timer demo, uses a COG to keep time )

0 VALUE timer_cog

#12 QBYTES timer_data ( save space for three longs )

: timer_lock
  timer_data #4 + ; 

: timer_ticks 
  timer_data #8 + ; 

LOCK-NEW S>D timer_lock Q! 

CLKFREQ #100. D/ timer_ticks Q!

: timer-lock ( -- ) 
  BEGIN 
    timer_lock Q@ D>S LOCK-SET
  UNTIL ; 
  
: timer-unlock ( -- )
  timer_lock Q@ D>S LOCK-CLR DROP ;

: bcdtime. ( dBcdTime -- )
  \ save current numeric base and set to base 16 
  BASE @ >R HEX
  \ format value as BCD time with seperators
  <# # # $2E HOLD # # $3A HOLD # # $3A HOLD # # #> 
  TYPE
  \ restore save numeric base value
  R> BASE ! ;
  
: timer. ( -- ) 
  timer_data Q@ bcdtime. ;

: set-timer ( dBcdTime -- )
  timer-lock timer_data Q! timer-unlock ;

: clr-timer ( -- )
  0. set-timer ;

MARKER timer-code

\ This constant must reflect the block number 
\ used to store COG binary image.
#13 CONSTANT timer_block

: init-timer ( -- ) 
  timer_data timer_block COG-LOAD DUP TO timer_cog
  ." Timer started on COG " . CR timer-code ;
  
init-timer
